﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <cassert>
#include <map>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;

const int INT_INF = 1e9 + 10;
const int LL_INF = 1e18 + 10;

struct Dot {
	ll type;
	ll x, y;
	Dot() : x(0), y(0) {}
	Dot(ll _x, ll _y) : type(0), x(_x), y(_y) {}
	Dot(ll _type, ll _x, ll _y) : type(_type), x(_x), y(_y) {}
	Dot(ll _type, Dot d) : type(_type), x(d.x), y(d.y) {}
};
/*
struct Segm {
	ll x, y, h;
	Segm() : x(0), y(0), h(0) {}
	Segm(ll _x, ll _y, ll _h) : x(_x), y(_y), h(_h) {}
	Segm(Dot _a, Dot _b) : x(_a.x, )
};
*/

class Segment_tree {
	int n;
	vector<ll> tree;
	void _update(int u, int l, int r, int i, ll delta) {

	}
public:
	Segment_tree(int max_y) {
		n = max_y;
		tree.resize(4 * n);
	}
	void update(int i, ll delta) {
		_update(0, 0, n, i, delta);
	}
};

int main() {
	ll k, n;
	cin >> k >> n;
	vector<Dot> t{ Dot(0, 0), Dot(0, k), Dot(k, k), Dot(k, 0) };
	vector<Dot> dots;
	vector<pair<Dot, Dot>> sides;
	for (int i = 0; i < n; i++) {
		char d;
		ll a;
		cin >> d >> a;
		vector<Dot> next_t = t;
		if (d == 'N') {
			for (int j = 0; j < 4; j++) {
				next_t[j].y += a;
			}
			dots.push_back(Dot(1, t[0]));
			dots.push_back(Dot(1, next_t[1]));
			dots.push_back(Dot(0, next_t[2]));
			dots.push_back(Dot(0, t[3]));

			sides.push_back(make_pair(Dot(1, t[0]), Dot(1, next_t[1])));
			sides.push_back(make_pair(Dot(0, next_t[2]), Dot(0, t[3])));
		}
		else if (d == 'S') {
			for (int j = 0; j < 4; j++) {
				next_t[j].y -= a;
			}
			dots.push_back(Dot(1, next_t[0]));
			dots.push_back(Dot(1, t[1]));
			dots.push_back(Dot(0, t[2]));
			dots.push_back(Dot(0, next_t[3]));

			sides.push_back(make_pair(Dot(1, next_t[0]), Dot(1, t[1])));
			sides.push_back(make_pair(Dot(0, t[2]), Dot(0, next_t[3])));
		}
		else if (d == 'W') {
			for (int j = 0; j < 4; j++) {
				next_t[j].x -= a;
			}
			dots.push_back(Dot(1, next_t[0]));
			dots.push_back(Dot(1, next_t[1]));
			dots.push_back(Dot(0, t[2]));
			dots.push_back(Dot(0, t[3]));

			sides.push_back(make_pair(Dot(1, next_t[0]), Dot(1, next_t[1])));
			sides.push_back(make_pair(Dot(0, t[2]), Dot(0, t[3])));
		}
		else if (d == 'E') {
			for (int j = 0; j < 4; j++) {
				next_t[j].x += a;
			}
			dots.push_back(Dot(1, t[0]));
			dots.push_back(Dot(1, t[1]));
			dots.push_back(Dot(0, next_t[2]));
			dots.push_back(Dot(0, next_t[3]));

			sides.push_back(make_pair(Dot(1, t[0]), Dot(1, t[1])));
			sides.push_back(make_pair(Dot(0, next_t[2]), Dot(0, next_t[3])));
		}
		t = next_t;
	}
	//пожали по y
	sort(dots.begin(), dots.end(), [](Dot _a, Dot _b) {return _a.y < _b.y; });
	ll max_y = 0;
	unordered_map<ll, ll> compress;
	vector<ll> decompress;
	for (int i = 0; i < dots.size(); max_y++) {
		int j = i;
		while (j < dots.size() && dots[i].y == dots[j].y) {
			j++;
		}
		compress[dots[i].y] = max_y;
		decompress.push_back(dots[i].y);
		i = j;
	}
	//непосредственно решение
	sort(sides.begin(), sides.end(), [](pair<Dot, Dot> _a, pair<Dot, Dot> _b) {return _a.first.x < _b.first.x; });
	for (auto& p : sides) {
		if (p.first.y > p.second.y) {
			swap(p.first, p.second);
		}
	}
	ll last_x = sides[0].first.x;
	//Segment_tree tree(max_y);
	vector<ll> hz(max_y, 0);
	ll ans = 0;
	for (int i = 0; i < sides.size();) {
		int last_not_zero = -1;
		ll sum = 0, bal = 0;
		for (int j = 0; j < max_y; j++) {
			if (last_not_zero != -1) {
				sum += decompress[j] - decompress[last_not_zero];
			}
			bal += hz[j];
			if (bal == 0) {
				last_not_zero = -1;
			}
			else {
				last_not_zero = j;
			}
		}
		ans += (sides[i].first.x - last_x) * sum;
		last_x = sides[i].first.x;
		int j = i;
		while (j < sides.size() && sides[j].first.x == sides[i].first.x) {
			if (sides[j].first.type == 1) {
				hz[compress[sides[j].first.y]]++;
				hz[compress[sides[j].second.y]]--;
			}
			else {
				hz[compress[sides[j].first.y]]--;
				hz[compress[sides[j].second.y]]++;
			}
			j++;
		}
		i = j;
	}
	cout << ans;
}