﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <cassert>
#include <map>
#include <unordered_map>

using namespace std;
using ll = long long;
using ld = long double;

const int INT_INF = 1e9 + 10;
const int LL_INF = 1e18 + 10;
const ld PI = acos(-1);

struct Vector {
	ll x, y, num;
	Vector() : x(0), y(0) {}
	Vector(ll _x, ll _y) : x(_x), y(_y) {}
	Vector(ll _x, ll _y, ll _num) : x(_x), y(_y), num(_num) {}
	Vector(ll x1, ll y1, ll x2, ll y2) : x(x2 - x1), y(y2 - y1) {}
	Vector(Vector _a, Vector _b) : x(_b.x - _a.x), y(_b.y - _a.y) {}

};

Vector operator - (Vector _a, Vector _b) {
	return Vector(_b.x - _a.x, _b.y - _a.y);
}
Vector operator + (Vector _a, Vector _b) {
	return Vector(_b.x + _a.x, _b.y + _a.y);
}

istream& operator >> (istream& in, Vector& a) {
	in >> a.x >> a.y;
	return in;
}

ll cross_product(Vector a, Vector b) {
	return a.x * b.x + a.y * b.y;
}

ll dot_product(Vector a, Vector b) {
	return a.x * b.y - a.y * b.x;
}

ll dist_sq(Vector a, Vector b) {
	return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}

ll len_sq(Vector a) {
	return a.x * a.x + a.y * a.y;
}

ld angle(Vector a, Vector b) {
	return atan2(dot_product(a, b), cross_product(a, b));
}

vector<Vector> a;
int n, t;
Vector dir;
Vector start;
Vector next_i;

bool cmp(Vector a, Vector b) {
	if (b.num == next_i.num) {
		return true;
	}
	else if (a.num == next_i.num) {
		return false;
	}
	a = Vector(next_i, a);
	b = Vector(next_i, b);
	if (dot_product(a, b) == 0) {
		return len_sq(a) < len_sq(b);
	}
	ld angle_a = angle(dir, a);
	ld angle_b = angle(dir, b);
	if (angle_a < 0) {
		angle_a += 2 * PI;
	}
	if (angle_b < 0) {
		angle_b += 2 * PI;
	}
	return angle_a < angle_b;
}

int f(int i, int j) {
	sort(a.begin(), a.end(), [](Vector _a, Vector _b) {return _a.num < _b.num; });
	start = a[i];
	next_i = a[j];
	dir = Vector(a[i], a[j]);
	sort(a.begin(), a.end(), cmp);
	map<pair<int, int>, int> order;
	order[make_pair(i, j)] = order.size();
	vector<pair<int, int>> list = {make_pair(i, j)};
	while (true) {
		pair<int, int> para = make_pair(next_i.num, a[t].num);
		if (order.find(para) != order.end()) {
			if (next_i.num == i && a[t].num == j) {
				return 2;
			}
			else {
				for (int ptr = 1; ptr < list.size(); ptr++) {
					if (list[ptr].first == i) {
						return 1;
					}
				}
				return 0;
			}
		}
		start = next_i;
		next_i = a[t];
		dir = Vector(start, next_i);
		order[para] = order.size();
		list.push_back(para);
		sort(a.begin(), a.end(), cmp);
	}
}

int main() {
	cin >> n >> t;
	t--;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i].num = i;
	}
	/*
	sort(a.begin(), a.end(), [](Vector _a, Vector _b) {if (_a.x != _b.x) {
		return _a.x < _b.x;
	}
	return _a.y < _b.y; });
	bool on_line = true;
	for (int i = 2; i < n && on_line; i++) {
		if (dot_product(Vector(a[i - 2], a[i - 1]), Vector(a[i - 2], a[i])) != 0) {
			on_line = false;
		}
	}
	if (on_line) {

	}
	*/
	if (n <= 1000000) {
		for (int i = 0; i < n; i++) {
			int type = 0;
			for (int j = 0; j < n; j++) {
				if (j == i) {
					continue;
				}
				type = max(type, f(i, j));
			}
			if (type == 0) {
				cout << 'R';
			}
			else if (type == 1) {
				cout << 'B';
			}
			else {
				cout << 'G';
			}
		}
	}
}