#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <stack>
#include <queue>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

const int INF_INF = 1e9 + 10;
const ll LL_INF = 1e18 + 10;
const ld PI = acos(-1);

const int MOD = 1e9 + 7;

int sum(int a, int b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	}
	return a + b;
}

vector<int> a;
int n, m;

int short_solve(vector<int> s) {
	int res = 0;
	if (s.size() == n) {
		return 1;
	}
	for (int i = 0; i < m; i++) {
		bool able = true;
		for (int j = s.size() - 1; j >= 0 && (int)s.size() - j < a[i] && able; j--) {
			if (s[j] == a[i]) {
				able = false;
			}
		}
		if (able) {
			vector<int> next_s = s;
			next_s.push_back(a[i]);
			res = sum(res, short_solve(next_s));
		}
	}
	return res;
}

const int MAXD = 7;
const int BOUND = 10000000;
bool dir[10000000][8];
vector<vector<int>> dp(2, vector<int>(BOUND));
vector<int> correct;
int fr = 0, to = 1;

void init(int s) {
	if (s * 10 > BOUND) {
		dp[fr][s]++;
		correct.push_back(s);
		return;
	}
	vector<int> s_vec;
	int s_copy = s;
	while (s_copy != 0) {
		s_vec.push_back(s_copy % 10);
		s_copy /= 10;
	}
	reverse(s_vec.begin(), s_vec.end());
	int res = 0;
	for (int i = 0; i < m; i++) {
		bool able = true;
		for (int j = s_vec.size() - 1; j >= 0 && (int)s_vec.size() - j < a[i] && able; j--) {
			if (s_vec[j] == i + 1) {
				able = false;
			}
		}
		if (able) {
			int next_s = s * 10 + i + 1;
			init(next_s);
		}
	}
}

int main() {
	cin >> n >> m;
	a.resize(m);
	for (auto& i : a) {
		cin >> i;
	}
	if (n < MAXD) {
		cout << short_solve(vector<int>());
	}
	else {
		assert(false);
		for (int i = 0; i < m; i++) {
			init(i);
		}
		for (auto s : correct) {
			vector<int> s_vec;
			int s_copy = s;
			while (s_copy != 0) {
				s_vec.push_back(s_copy % 10);
				s_copy /= 10;
			}
			reverse(s_vec.begin(), s_vec.end());
			for (int i = 0; i < m; i++) {
				bool able = true;
				for (int j = s_vec.size() - 1; j >= 0 && (int)s_vec.size() - j < a[i] && able; j--) {
					if (s_vec[j] == i + 1) {
						able = false;
					}
				}
				dir[s][i] = able;
			}
		}
		for (int i = 0; i + MAXD < n; i++) {
			for (auto s : correct) {
				for (int i = 0; i < m; i++) {
					if (dir[s][i]) {
						dp[to][s % (BOUND / 10) * 10 + i + 1] = sum(dp[to][s % (BOUND / 10)], dp[fr][s]);
					}
				}
			}
			swap(to, fr);
			dp[to].assign(BOUND, 0);
		}
		int ans = 0;
		for (auto s : correct) {
			ans = sum(ans, dp[fr][s]);
		}
		cout << ans;
	}
}
