#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <stack>
#include <queue>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

const int INF_INF = 1e9 + 10;
const ll LL_INF = 1e18 + 10;
const ld PI = acos(-1);

const int MOD = 1e9 + 7;

int sum(int a, int b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	}
	return a + b;
}

int main() {
	int n, q;
	cin >> n >> q;
	vector<int> a(n);
	bool ascend = true;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		a[i]--;
		if (i > 0 && a[i] < a[i - 1]) {
			ascend = false;
		}
	}
	if (n <= 3000) {
		vector<vector<int>> cnt(n, vector<int>(n, 0));
		for (int start = 0; start < n; start++) {
			cnt[start][0]++;
			int l = start, r = start;
			int move = 1;
			while (l > 0 && r < n - 1) {
				if (a[l - 1] < a[r + 1]) {
					cnt[a[l - 1]][move]++;
					l--;
				} else {
					cnt[a[r + 1]][move]++;
					r++;
				}
				move++;
			}
			while (l > 0) {
				cnt[a[l - 1]][move]++;
				l--;
				move++;
			}
			while (r < n - 1) {
				cnt[a[r + 1]][move]++;
				r++;
				move++;
			}
		}
		while (q--) {
			int p, k;
			cin >> p >> k;
			p--;
			k--;
			cout << cnt[a[p]][k] << '\n';
		}
	}
	else if (ascend) {
		while (q--) {
			int p, k;
			cin >> p >> k;
			p--;
			k--;
			int ans = 1;
			if (k == p) {
				ans += p;
			}
			cout << ans << '\n';
		}
	}
}
